#ifndef DGX_BEZIER_3D_H
#define DGX_BEZIER_3D_H

#include <engine/psx.h>
#include <engine/3d/render.h>

#define MAX_BEZIER_KEY		6	/* key as in keypoint */
#define MAX_BEZIER_PRIM		225	/* MUST be a multiple of 3 */
#define BEZIER_UNIT		(USHRT_MAX/MAX_BEZIER_PRIM)

struct Bezier3D
{
	unsigned int	nkeys;
	CVECTOR		rgbc;
	int		radius;

	VECTOR		key[MAX_BEZIER_KEY]; /* 12fb (basically the same format as encoded in the MTD/ATD/etc... formats */
	TILE		keyprim[MAX_BEZIER_KEY];

	VECTOR		tilepos[MAX_BEZIER_PRIM]; /* 6fb */
	TILE		tile[MAX_BEZIER_PRIM];

	struct
	{
		int		t;	/* 0.16 */
		VECTOR		coords; /* 6fb */
		TILE		tile;
		CVECTOR		rgbc;
	}cursor;

	struct
	{
		int prev, cur;
	}col;
};

#endif

